/* A Bison parser, made by GNU Bison 2.6.4.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         sieveparse
#define yylex           sievelex
#define yyerror         sieveerror
#define yylval          sievelval
#define yychar          sievechar
#define yydebug         sievedebug
#define yynerrs         sievenerrs

/* Copy the first part of user declarations.  */
/* Line 358 of yacc.c  */
#line 1 "sieve/sieve.y"

/* sieve.y -- sieve parser
 * Larry Greenfield
 *
 * Copyright (c) 1994-2008 Carnegie Mellon University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The name "Carnegie Mellon University" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For permission or any legal
 *    details, please contact
 *      Carnegie Mellon University
 *      Center for Technology Transfer and Enterprise Creation
 *      4615 Forbes Avenue
 *      Suite 302
 *      Pittsburgh, PA  15213
 *      (412) 268-7393, fax: (412) 268-7395
 *      innovation@andrew.cmu.edu
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Computing Services
 *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
 *
 * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "xmalloc.h"
#include "sieve/comparator.h"
#include "sieve/interp.h"
#include "sieve/script.h"
#include "sieve/tree.h"

#include "imapurl.h"
#include "lib/gmtoff.h"
#include "util.h"
#include "imparse.h"
#include "libconfig.h"
#include "times.h"

#define ERR_BUF_SIZE 1024

/* definitions */
extern int addrparse(sieve_script_t*);
typedef struct yy_buffer_state *YY_BUFFER_STATE;
extern YY_BUFFER_STATE addr_scan_string(const char*);
extern void addr_delete_buffer(YY_BUFFER_STATE);

extern int sievelineno;

struct vtags {
    int seconds;
    strarray_t *addresses;
    char *subject;
    char *from;
    char *handle;
    int mime;
};

struct htags {
    char *comparator;
    int comptag;
    int relation;
};

struct aetags {
    int addrtag;
    char *comparator;
    int comptag;
    int relation;
};

struct btags {
    int transform;
    int offset;
    strarray_t *content_types;
    char *comparator;
    int comptag;
    int relation;
};

struct ntags {
    char *method;
    char *id;
    strarray_t *options;
    int priority;
    char *message;
};

struct dtags {
    int comptag;
    int relation;
    void *pattern;
    int priority;
};

struct itags {
  int location;
  int once;
  int optional;
};

struct dttags {
    int zonetag;
    char *zone;
    int comptag;
    int relation;
    char *comparator;
    int date_part;
};

static char *check_reqs(sieve_script_t *script, strarray_t *sl);
static test_t *build_address(int t, struct aetags *ae,
			     strarray_t *sl, strarray_t *pl);
static test_t *build_header(int t, struct htags *h,
			    strarray_t *sl, strarray_t *pl);
static test_t *build_body(int t, struct btags *b, strarray_t *pl);
static test_t *build_date(int t, struct dttags *dt, char *hn, strarray_t *kl);
static commandlist_t *build_vacation(int t, struct vtags *h, char *s);
static commandlist_t *build_notify(int t, struct ntags *n);
static commandlist_t *build_denotify(int t, struct dtags *n);
static commandlist_t *build_fileinto(int t, int c, char *f);
static commandlist_t *build_redirect(int t, int c, char *a);
static commandlist_t *build_include(int, struct itags *, char*);
static struct aetags *new_aetags(void);
static struct aetags *canon_aetags(struct aetags *ae);
static void free_aetags(struct aetags *ae);
static struct htags *new_htags(void);
static struct htags *canon_htags(struct htags *h);
static void free_htags(struct htags *h);
static struct btags *new_btags(void);
static struct btags *canon_btags(struct btags *b);
static void free_btags(struct btags *b);
static struct vtags *new_vtags(void);
static struct vtags *canon_vtags(sieve_script_t *script, struct vtags *v);
static void free_vtags(struct vtags *v);
static struct ntags *new_ntags(void);
static struct ntags *canon_ntags(struct ntags *n);
static void free_ntags(struct ntags *n);
static struct dtags *new_dtags(void);
static struct dtags *canon_dtags(struct dtags *d);
static void free_dtags(struct dtags *d);
static struct itags *new_itags(void);
static struct dttags *new_dttags(void);
static struct dttags *canon_dttags(struct dttags *dt);
static void free_dttags(struct dttags *b);

static int verify_stringlist(sieve_script_t*, strarray_t *sl, int (*verify)(sieve_script_t*, char *));
static int verify_mailbox(sieve_script_t*, char *s);
static int verify_address(sieve_script_t*, char *s);
static int verify_header(sieve_script_t*, char *s);
static int verify_addrheader(sieve_script_t*, char *s);
static int verify_envelope(sieve_script_t*, char *s);
static int verify_flag(sieve_script_t*, char *s);
static int verify_relat(sieve_script_t*, char *s);
static int verify_zone(sieve_script_t*, char *s);
static int verify_date_part(sieve_script_t *parse_script, char *dp);
#ifdef ENABLE_REGEX
static int verify_regex(sieve_script_t*, char *s, int cflags);
static int verify_regexs(sieve_script_t*,const strarray_t *sl, char *comp);
#endif
static int verify_utf8(sieve_script_t*, char *s);

void yyerror(sieve_script_t*, const char *msg);
extern int yylex(void*, sieve_script_t*);
extern void sieverestart(FILE *f);

#define YYERROR_VERBOSE /* i want better error messages! */

/* byacc default is 500, bison default is 10000 - go with the
   larger to support big sieve scripts (see Bug #3461) */
#define YYSTACKSIZE 10000

/* Line 358 of yacc.c  */
#line 273 "sieve/sieve.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_SIEVE_SIEVE_SIEVE_H_INCLUDED
# define YY_SIEVE_SIEVE_SIEVE_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int sievedebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER = 258,
     STRING = 259,
     IF = 260,
     ELSIF = 261,
     ELSE = 262,
     REJCT = 263,
     FILEINTO = 264,
     REDIRECT = 265,
     KEEP = 266,
     STOP = 267,
     DISCARD = 268,
     VACATION = 269,
     REQUIRE = 270,
     SETFLAG = 271,
     ADDFLAG = 272,
     REMOVEFLAG = 273,
     MARK = 274,
     UNMARK = 275,
     NOTIFY = 276,
     DENOTIFY = 277,
     ANYOF = 278,
     ALLOF = 279,
     EXISTS = 280,
     SFALSE = 281,
     STRUE = 282,
     HEADER = 283,
     NOT = 284,
     SIZE = 285,
     ADDRESS = 286,
     ENVELOPE = 287,
     BODY = 288,
     COMPARATOR = 289,
     IS = 290,
     CONTAINS = 291,
     MATCHES = 292,
     REGEX = 293,
     COUNT = 294,
     VALUE = 295,
     OVER = 296,
     UNDER = 297,
     GT = 298,
     GE = 299,
     LT = 300,
     LE = 301,
     EQ = 302,
     NE = 303,
     ALL = 304,
     LOCALPART = 305,
     DOMAIN = 306,
     USER = 307,
     DETAIL = 308,
     RAW = 309,
     TEXT = 310,
     CONTENT = 311,
     DAYS = 312,
     ADDRESSES = 313,
     SUBJECT = 314,
     FROM = 315,
     HANDLE = 316,
     MIME = 317,
     SECONDS = 318,
     METHOD = 319,
     ID = 320,
     OPTIONS = 321,
     LOW = 322,
     NORMAL = 323,
     HIGH = 324,
     ANY = 325,
     MESSAGE = 326,
     INCLUDE = 327,
     PERSONAL = 328,
     GLOBAL = 329,
     RETURN = 330,
     OPTIONAL = 331,
     ONCE = 332,
     COPY = 333,
     DATE = 334,
     CURRENTDATE = 335,
     ZONE = 336,
     ORIGINALZONE = 337,
     YEAR = 338,
     MONTH = 339,
     DAY = 340,
     JULIAN = 341,
     HOUR = 342,
     MINUTE = 343,
     SECOND = 344,
     TIME = 345,
     ISO8601 = 346,
     STD11 = 347,
     WEEKDAY = 348
   };
#endif
/* Tokens.  */
#define NUMBER 258
#define STRING 259
#define IF 260
#define ELSIF 261
#define ELSE 262
#define REJCT 263
#define FILEINTO 264
#define REDIRECT 265
#define KEEP 266
#define STOP 267
#define DISCARD 268
#define VACATION 269
#define REQUIRE 270
#define SETFLAG 271
#define ADDFLAG 272
#define REMOVEFLAG 273
#define MARK 274
#define UNMARK 275
#define NOTIFY 276
#define DENOTIFY 277
#define ANYOF 278
#define ALLOF 279
#define EXISTS 280
#define SFALSE 281
#define STRUE 282
#define HEADER 283
#define NOT 284
#define SIZE 285
#define ADDRESS 286
#define ENVELOPE 287
#define BODY 288
#define COMPARATOR 289
#define IS 290
#define CONTAINS 291
#define MATCHES 292
#define REGEX 293
#define COUNT 294
#define VALUE 295
#define OVER 296
#define UNDER 297
#define GT 298
#define GE 299
#define LT 300
#define LE 301
#define EQ 302
#define NE 303
#define ALL 304
#define LOCALPART 305
#define DOMAIN 306
#define USER 307
#define DETAIL 308
#define RAW 309
#define TEXT 310
#define CONTENT 311
#define DAYS 312
#define ADDRESSES 313
#define SUBJECT 314
#define FROM 315
#define HANDLE 316
#define MIME 317
#define SECONDS 318
#define METHOD 319
#define ID 320
#define OPTIONS 321
#define LOW 322
#define NORMAL 323
#define HIGH 324
#define ANY 325
#define MESSAGE 326
#define INCLUDE 327
#define PERSONAL 328
#define GLOBAL 329
#define RETURN 330
#define OPTIONAL 331
#define ONCE 332
#define COPY 333
#define DATE 334
#define CURRENTDATE 335
#define ZONE 336
#define ORIGINALZONE 337
#define YEAR 338
#define MONTH 339
#define DAY 340
#define JULIAN 341
#define HOUR 342
#define MINUTE 343
#define SECOND 344
#define TIME 345
#define ISO8601 346
#define STD11 347
#define WEEKDAY 348



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 374 of yacc.c  */
#line 199 "sieve/sieve.y"

    int nval;
    char *sval;
    strarray_t *sl;
    test_t *test;
    testlist_t *testl;
    commandlist_t *cl;
    struct vtags *vtag;
    struct aetags *aetag;
    struct htags *htag;
    struct btags *btag;
    struct ntags *ntag;
    struct dtags *dtag;
    struct itags *itag;
    struct dttags *dttag;


/* Line 374 of yacc.c  */
#line 520 "sieve/sieve.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int sieveparse (void *YYPARSE_PARAM);
#else
int sieveparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int sieveparse (sieve_script_t *parse_script);
#else
int sieveparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_SIEVE_SIEVE_SIEVE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 377 of yacc.c  */
#line 547 "sieve/sieve.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  8
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   304

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  102
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  29
/* YYNRULES -- Number of rules.  */
#define YYNRULES  117
/* YYNRULES -- Number of states.  */
#define YYNSTATES  186

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   348

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     100,   101,     2,     2,    97,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    94,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    95,     2,    96,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    98,     2,    99,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    12,    16,    18,    21,
      24,    29,    32,    33,    38,    41,    44,    48,    52,    54,
      56,    58,    62,    65,    68,    71,    73,    75,    78,    81,
      85,    87,    88,    91,    94,    97,   100,   101,   105,   109,
     113,   116,   120,   121,   124,   128,   132,   134,   136,   138,
     139,   143,   147,   151,   155,   159,   163,   166,   170,   172,
     174,   178,   182,   185,   188,   191,   194,   196,   198,   203,
     208,   212,   215,   219,   225,   231,   233,   235,   237,   238,
     241,   244,   248,   252,   253,   256,   260,   264,   265,   268,
     271,   275,   278,   282,   286,   287,   290,   294,   298,   302,
     305,   307,   309,   311,   313,   315,   317,   319,   321,   323,
     325,   327,   329,   331,   332,   334,   338,   340
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     103,     0,    -1,   104,    -1,   104,   106,    -1,    -1,   105,
     104,    -1,    15,   115,    94,    -1,   107,    -1,   107,   106,
      -1,   109,    94,    -1,     5,   118,   117,   108,    -1,     1,
      94,    -1,    -1,     6,   118,   117,   108,    -1,     7,   117,
      -1,     8,     4,    -1,     9,   128,     4,    -1,    10,   128,
       4,    -1,    11,    -1,    12,    -1,    13,    -1,    14,   114,
       4,    -1,    16,   115,    -1,    17,   115,    -1,    18,   115,
      -1,    19,    -1,    20,    -1,    21,   111,    -1,    22,   112,
      -1,    72,   110,     4,    -1,    75,    -1,    -1,   110,    73,
      -1,   110,    74,    -1,   110,    77,    -1,   110,    76,    -1,
      -1,   111,    65,     4,    -1,   111,    64,     4,    -1,   111,
      66,   115,    -1,   111,   113,    -1,   111,    71,     4,    -1,
      -1,   112,   113,    -1,   112,   125,     4,    -1,   112,   126,
       4,    -1,    67,    -1,    68,    -1,    69,    -1,    -1,   114,
      57,     3,    -1,   114,    63,     3,    -1,   114,    58,   115,
      -1,   114,    59,     4,    -1,   114,    60,     4,    -1,   114,
      61,     4,    -1,   114,    62,    -1,    95,   116,    96,    -1,
       4,    -1,     4,    -1,   116,    97,     4,    -1,    98,   106,
      99,    -1,    98,    99,    -1,    23,   129,    -1,    24,   129,
      -1,    25,   115,    -1,    26,    -1,    27,    -1,    28,   121,
     115,   115,    -1,   119,   120,   115,   115,    -1,    33,   122,
     115,    -1,    29,   118,    -1,    30,   127,     3,    -1,    79,
     123,     4,     4,   115,    -1,    80,   123,     4,     4,   115,
      -1,     1,    -1,    31,    -1,    32,    -1,    -1,   120,   124,
      -1,   120,   125,    -1,   120,   126,     4,    -1,   120,    34,
       4,    -1,    -1,   121,   125,    -1,   121,   126,     4,    -1,
     121,    34,     4,    -1,    -1,   122,    54,    -1,   122,    55,
      -1,   122,    56,   115,    -1,   122,   125,    -1,   122,   126,
       4,    -1,   122,    34,     4,    -1,    -1,   123,   125,    -1,
     123,   126,     4,    -1,   123,    34,     4,    -1,   123,    81,
       4,    -1,   123,    82,    -1,    49,    -1,    50,    -1,    51,
      -1,    52,    -1,    53,    -1,    35,    -1,    36,    -1,    37,
      -1,    38,    -1,    39,    -1,    40,    -1,    41,    -1,    42,
      -1,    -1,    78,    -1,   100,   130,   101,    -1,   118,    -1,
     118,    97,   130,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   258,   258,   259,   262,   263,   266,   274,   275,   278,
     279,   280,   283,   284,   285,   288,   297,   305,   309,   310,
     311,   312,   321,   330,   339,   348,   353,   359,   367,   377,
     390,   397,   398,   401,   404,   407,   412,   413,   416,   419,
     422,   425,   430,   431,   434,   449,   459,   460,   461,   464,
     465,   468,   475,   483,   489,   495,   501,   507,   508,   514,
     518,   524,   525,   528,   529,   530,   531,   532,   533,   557,
     579,   605,   606,   608,   621,   634,   637,   638,   645,   646,
     651,   655,   663,   673,   674,   678,   686,   696,   697,   702,
     707,   715,   719,   727,   737,   738,   743,   752,   760,   769,
     775,   776,   777,   778,   783,   789,   790,   791,   792,   799,
     804,   812,   813,   816,   817,   824,   827,   828
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER", "STRING", "IF", "ELSIF",
  "ELSE", "REJCT", "FILEINTO", "REDIRECT", "KEEP", "STOP", "DISCARD",
  "VACATION", "REQUIRE", "SETFLAG", "ADDFLAG", "REMOVEFLAG", "MARK",
  "UNMARK", "NOTIFY", "DENOTIFY", "ANYOF", "ALLOF", "EXISTS", "SFALSE",
  "STRUE", "HEADER", "NOT", "SIZE", "ADDRESS", "ENVELOPE", "BODY",
  "COMPARATOR", "IS", "CONTAINS", "MATCHES", "REGEX", "COUNT", "VALUE",
  "OVER", "UNDER", "GT", "GE", "LT", "LE", "EQ", "NE", "ALL", "LOCALPART",
  "DOMAIN", "USER", "DETAIL", "RAW", "TEXT", "CONTENT", "DAYS",
  "ADDRESSES", "SUBJECT", "FROM", "HANDLE", "MIME", "SECONDS", "METHOD",
  "ID", "OPTIONS", "LOW", "NORMAL", "HIGH", "ANY", "MESSAGE", "INCLUDE",
  "PERSONAL", "GLOBAL", "RETURN", "OPTIONAL", "ONCE", "COPY", "DATE",
  "CURRENTDATE", "ZONE", "ORIGINALZONE", "YEAR", "MONTH", "DAY", "JULIAN",
  "HOUR", "MINUTE", "SECOND", "TIME", "ISO8601", "STD11", "WEEKDAY", "';'",
  "'['", "']'", "','", "'{'", "'}'", "'('", "')'", "$accept", "start",
  "reqs", "require", "commands", "command", "elsif", "action", "itags",
  "ntags", "dtags", "priority", "vtags", "stringlist", "strings", "block",
  "test", "addrorenv", "aetags", "htags", "btags", "dttags", "addrparttag",
  "comptag", "relcomp", "sizetag", "copy", "testlist", "tests", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,    59,    91,    93,    44,   123,   125,
      40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   102,   103,   103,   104,   104,   105,   106,   106,   107,
     107,   107,   108,   108,   108,   109,   109,   109,   109,   109,
     109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
     109,   110,   110,   110,   110,   110,   111,   111,   111,   111,
     111,   111,   112,   112,   112,   112,   113,   113,   113,   114,
     114,   114,   114,   114,   114,   114,   114,   115,   115,   116,
     116,   117,   117,   118,   118,   118,   118,   118,   118,   118,
     118,   118,   118,   118,   118,   118,   119,   119,   120,   120,
     120,   120,   120,   121,   121,   121,   121,   122,   122,   122,
     122,   122,   122,   122,   123,   123,   123,   123,   123,   123,
     124,   124,   124,   124,   124,   125,   125,   125,   125,   126,
     126,   127,   127,   128,   128,   129,   130,   130
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     2,     3,     1,     2,     2,
       4,     2,     0,     4,     2,     2,     3,     3,     1,     1,
       1,     3,     2,     2,     2,     1,     1,     2,     2,     3,
       1,     0,     2,     2,     2,     2,     0,     3,     3,     3,
       2,     3,     0,     2,     3,     3,     1,     1,     1,     0,
       3,     3,     3,     3,     3,     3,     2,     3,     1,     1,
       3,     3,     2,     2,     2,     2,     1,     1,     4,     4,
       3,     2,     3,     5,     5,     1,     1,     1,     0,     2,
       2,     3,     3,     0,     2,     3,     3,     0,     2,     2,
       3,     2,     3,     3,     0,     2,     3,     3,     3,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       4,     0,     0,     0,     4,    58,     0,     0,     1,     0,
       0,     0,   113,   113,    18,    19,    20,    49,     0,     0,
       0,    25,    26,    36,    42,    31,    30,     3,     0,     0,
       5,    59,     0,     6,    11,    75,     0,     0,     0,    66,
      67,    83,     0,     0,    76,    77,    87,    94,    94,     0,
      78,    15,   114,     0,     0,     0,    22,    23,    24,    27,
      28,     0,     8,     9,    57,     0,     0,    63,    64,    65,
       0,    71,   111,   112,     0,     0,     0,     0,     0,    12,
       0,    16,    17,    21,     0,     0,     0,     0,     0,    56,
       0,     0,     0,     0,    46,    47,    48,     0,    40,   105,
     106,   107,   108,   109,   110,    43,     0,     0,    29,    32,
      33,    35,    34,    60,   116,     0,     0,     0,    84,     0,
      72,     0,    88,    89,     0,    70,    91,     0,     0,     0,
       0,    99,    95,     0,     0,    62,     0,     0,     0,    10,
       0,   100,   101,   102,   103,   104,     0,    79,    80,     0,
      50,    52,    53,    54,    55,    51,    38,    37,    39,    41,
      44,    45,     0,   115,    86,    68,    85,    93,    90,    92,
       0,    97,    98,    96,     0,    61,     0,    14,    82,    69,
      81,   117,    73,    74,    12,    13
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,    27,    28,   139,    29,    61,    59,
      60,    98,    55,     7,    32,    79,   114,    50,    80,    70,
      75,    76,   147,   132,   133,    74,    53,    67,   115
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -111
static const yytype_int16 yypact[] =
{
      -4,     0,    32,   229,    -4,  -111,    30,   -51,  -111,   -43,
     135,    56,   -25,   -25,  -111,  -111,  -111,  -111,     0,     0,
       0,  -111,  -111,  -111,  -111,  -111,  -111,  -111,     5,   -33,
    -111,  -111,   -89,  -111,  -111,  -111,   -35,   -35,     0,  -111,
    -111,  -111,   135,   -11,  -111,  -111,  -111,  -111,  -111,   -30,
    -111,  -111,  -111,    66,    67,   142,  -111,  -111,  -111,   105,
     217,     8,  -111,  -111,  -111,    68,   135,  -111,  -111,  -111,
     103,  -111,  -111,  -111,    73,    54,   144,   151,    28,    49,
      82,  -111,  -111,  -111,    76,     0,    83,    92,    93,  -111,
      95,    97,    98,     0,  -111,  -111,  -111,   101,  -111,  -111,
    -111,  -111,  -111,  -111,  -111,  -111,   107,   108,  -111,  -111,
    -111,  -111,  -111,  -111,    16,    13,   111,     0,  -111,   119,
    -111,   120,  -111,  -111,     0,  -111,  -111,   121,   122,   125,
     140,  -111,  -111,   141,   143,  -111,    51,   135,   -30,  -111,
     147,  -111,  -111,  -111,  -111,  -111,     0,  -111,  -111,   149,
    -111,  -111,  -111,  -111,  -111,  -111,  -111,  -111,  -111,  -111,
    -111,  -111,   135,  -111,  -111,  -111,  -111,  -111,  -111,  -111,
       0,  -111,  -111,  -111,     0,  -111,   -30,  -111,  -111,  -111,
    -111,  -111,  -111,  -111,    49,  -111
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -111,  -111,   150,  -111,   -19,  -111,   -27,  -111,  -111,  -111,
    -111,   115,  -111,   -18,  -111,  -110,    -7,  -111,  -111,  -111,
    -111,   145,  -111,    -6,     3,  -111,   179,   157,    33
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -8
static const yytype_int16 yytable[] =
{
      56,    57,    58,    49,     5,    -7,     9,    64,    65,    62,
      10,     1,   108,    11,    12,    13,    14,    15,    16,    17,
      69,    18,    19,    20,    21,    22,    23,    24,   177,     9,
      72,    73,     8,    10,    31,    71,    11,    12,    13,    14,
      15,    16,    17,    33,    18,    19,    20,    21,    22,    23,
      24,    34,   117,    52,   106,   137,   138,   125,     5,   136,
      51,    63,   146,   107,   118,    66,   184,   151,    78,   126,
      81,    82,   113,   119,   148,   158,   120,    25,   127,   150,
      26,   109,   110,   149,   111,   112,     5,   152,   121,    99,
     100,   101,   102,   103,   104,     6,   153,   154,   155,   165,
      25,   156,   157,    26,    -7,   159,   168,     5,   122,   123,
     124,   160,   161,   162,   163,   164,   140,    99,   100,   101,
     102,   103,   104,   166,   167,   169,   170,   135,   179,   171,
     176,   141,   142,   143,   144,   145,    35,   116,    99,   100,
     101,   102,   103,   104,   172,   173,    83,   174,   128,     6,
     175,   178,   182,   180,    30,   134,   183,   185,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    91,
      92,    93,    94,    95,    96,   105,    97,     6,   129,    99,
     100,   101,   102,   103,   104,   129,    99,   100,   101,   102,
     103,   104,    54,    77,    68,   181,     0,     0,     6,    84,
      85,    86,    87,    88,    89,    90,     0,     0,     0,     0,
       0,     0,     0,     0,    47,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   130,   131,     0,     0,    -2,
       9,     0,   130,   131,    10,     0,     0,    11,    12,    13,
      14,    15,    16,    17,     0,    18,    19,    20,    21,    22,
      23,    24,    99,   100,   101,   102,   103,   104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    94,    95,    96,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    25,     0,     0,    26
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-111)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      18,    19,    20,    10,     4,     0,     1,    96,    97,    28,
       5,    15,     4,     8,     9,    10,    11,    12,    13,    14,
      38,    16,    17,    18,    19,    20,    21,    22,   138,     1,
      41,    42,     0,     5,     4,    42,     8,     9,    10,    11,
      12,    13,    14,    94,    16,    17,    18,    19,    20,    21,
      22,    94,    70,    78,    60,     6,     7,    75,     4,    78,
       4,    94,    80,    60,    70,   100,   176,    85,    98,    75,
       4,     4,     4,    70,    80,    93,     3,    72,    75,     3,
      75,    73,    74,    80,    76,    77,     4,     4,    34,    35,
      36,    37,    38,    39,    40,    95,     4,     4,     3,   117,
      72,     4,     4,    75,    99,     4,   124,     4,    54,    55,
      56,     4,     4,    97,   101,     4,    34,    35,    36,    37,
      38,    39,    40,     4,     4,     4,     4,    99,   146,     4,
     137,    49,    50,    51,    52,    53,     1,    34,    35,    36,
      37,    38,    39,    40,     4,     4,     4,     4,     4,    95,
      99,     4,   170,     4,     4,     4,   174,   184,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    64,
      65,    66,    67,    68,    69,    60,    71,    95,    34,    35,
      36,    37,    38,    39,    40,    34,    35,    36,    37,    38,
      39,    40,    13,    48,    37,   162,    -1,    -1,    95,    57,
      58,    59,    60,    61,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,     0,
       1,    -1,    81,    82,     5,    -1,    -1,     8,     9,    10,
      11,    12,    13,    14,    -1,    16,    17,    18,    19,    20,
      21,    22,    35,    36,    37,    38,    39,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    -1,    -1,    75
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    15,   103,   104,   105,     4,    95,   115,     0,     1,
       5,     8,     9,    10,    11,    12,    13,    14,    16,    17,
      18,    19,    20,    21,    22,    72,    75,   106,   107,   109,
     104,     4,   116,    94,    94,     1,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    79,    80,   118,
     119,     4,    78,   128,   128,   114,   115,   115,   115,   111,
     112,   110,   106,    94,    96,    97,   100,   129,   129,   115,
     121,   118,    41,    42,   127,   122,   123,   123,    98,   117,
     120,     4,     4,     4,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    71,   113,    35,
      36,    37,    38,    39,    40,   113,   125,   126,     4,    73,
      74,    76,    77,     4,   118,   130,    34,   115,   125,   126,
       3,    34,    54,    55,    56,   115,   125,   126,     4,    34,
      81,    82,   125,   126,     4,    99,   106,     6,     7,   108,
      34,    49,    50,    51,    52,    53,   115,   124,   125,   126,
       3,   115,     4,     4,     4,     3,     4,     4,   115,     4,
       4,     4,    97,   101,     4,   115,     4,     4,   115,     4,
       4,     4,     4,     4,     4,    99,   118,   117,     4,   115,
       4,   130,   115,   115,   117,   108
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (parse_script, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])



/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, parse_script)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, parse_script); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, sieve_script_t *parse_script)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, parse_script)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    sieve_script_t *parse_script;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (parse_script);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, sieve_script_t *parse_script)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, parse_script)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    sieve_script_t *parse_script;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, parse_script);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, sieve_script_t *parse_script)
#else
static void
yy_reduce_print (yyvsp, yyrule, parse_script)
    YYSTYPE *yyvsp;
    int yyrule;
    sieve_script_t *parse_script;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , parse_script);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, parse_script); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, sieve_script_t *parse_script)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, parse_script)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    sieve_script_t *parse_script;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (parse_script);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 106: /* commands */
/* Line 1405 of yacc.c  */
#line 251 "sieve/sieve.y"
	{ free_tree(((*yyvaluep).cl)); };
/* Line 1405 of yacc.c  */
#line 1702 "sieve/sieve.c"
	break;
      case 107: /* command */
/* Line 1405 of yacc.c  */
#line 251 "sieve/sieve.y"
	{ free_tree(((*yyvaluep).cl)); };
/* Line 1405 of yacc.c  */
#line 1709 "sieve/sieve.c"
	break;
      case 108: /* elsif */
/* Line 1405 of yacc.c  */
#line 251 "sieve/sieve.y"
	{ free_tree(((*yyvaluep).cl)); };
/* Line 1405 of yacc.c  */
#line 1716 "sieve/sieve.c"
	break;
      case 109: /* action */
/* Line 1405 of yacc.c  */
#line 251 "sieve/sieve.y"
	{ free_tree(((*yyvaluep).cl)); };
/* Line 1405 of yacc.c  */
#line 1723 "sieve/sieve.c"
	break;
      case 117: /* block */
/* Line 1405 of yacc.c  */
#line 251 "sieve/sieve.y"
	{ free_tree(((*yyvaluep).cl)); };
/* Line 1405 of yacc.c  */
#line 1730 "sieve/sieve.c"
	break;

      default:
	break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (sieve_script_t *parse_script)
#else
int
yyparse (parse_script)
    sieve_script_t *parse_script;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && (4 < __GNUC__ + (6 <= __GNUC_MINOR__))
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YYLVAL_INITIALIZE() (yylval = yyval_default)
#endif
#ifndef YYLVAL_INITIALIZE
# define YYLVAL_INITIALIZE()
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  YYLVAL_INITIALIZE ();
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1813 of yacc.c  */
#line 258 "sieve/sieve.y"
    { parse_script->cmds = NULL; }
    break;

  case 3:
/* Line 1813 of yacc.c  */
#line 259 "sieve/sieve.y"
    { parse_script->cmds = (yyvsp[(2) - (2)].cl); }
    break;

  case 6:
/* Line 1813 of yacc.c  */
#line 266 "sieve/sieve.y"
    { char *err = check_reqs(parse_script, (yyvsp[(2) - (3)].sl));
                                  if (err) {
				    yyerror(parse_script, err);
				    free(err);
				    YYERROR; 
                                  } }
    break;

  case 7:
/* Line 1813 of yacc.c  */
#line 274 "sieve/sieve.y"
    { (yyval.cl) = (yyvsp[(1) - (1)].cl); }
    break;

  case 8:
/* Line 1813 of yacc.c  */
#line 275 "sieve/sieve.y"
    { (yyvsp[(1) - (2)].cl)->next = (yyvsp[(2) - (2)].cl); (yyval.cl) = (yyvsp[(1) - (2)].cl); }
    break;

  case 9:
/* Line 1813 of yacc.c  */
#line 278 "sieve/sieve.y"
    { (yyval.cl) = (yyvsp[(1) - (2)].cl); }
    break;

  case 10:
/* Line 1813 of yacc.c  */
#line 279 "sieve/sieve.y"
    { (yyval.cl) = new_if((yyvsp[(2) - (4)].test), (yyvsp[(3) - (4)].cl), (yyvsp[(4) - (4)].cl)); }
    break;

  case 11:
/* Line 1813 of yacc.c  */
#line 280 "sieve/sieve.y"
    { (yyval.cl) = new_command(STOP); }
    break;

  case 12:
/* Line 1813 of yacc.c  */
#line 283 "sieve/sieve.y"
    { (yyval.cl) = NULL; }
    break;

  case 13:
/* Line 1813 of yacc.c  */
#line 284 "sieve/sieve.y"
    { (yyval.cl) = new_if((yyvsp[(2) - (4)].test), (yyvsp[(3) - (4)].cl), (yyvsp[(4) - (4)].cl)); }
    break;

  case 14:
/* Line 1813 of yacc.c  */
#line 285 "sieve/sieve.y"
    { (yyval.cl) = (yyvsp[(2) - (2)].cl); }
    break;

  case 15:
/* Line 1813 of yacc.c  */
#line 288 "sieve/sieve.y"
    { if (!parse_script->support.reject) {
				     yyerror(parse_script, "reject MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   if (!verify_utf8(parse_script, (yyvsp[(2) - (2)].sval))) {
				     YYERROR; /* vu should call yyerror() */
				   }
				   (yyval.cl) = new_command(REJCT);
				   (yyval.cl)->u.str = (yyvsp[(2) - (2)].sval); }
    break;

  case 16:
/* Line 1813 of yacc.c  */
#line 297 "sieve/sieve.y"
    { if (!parse_script->support.fileinto) {
				     yyerror(parse_script, "fileinto MUST be enabled with \"require\"");
	                             YYERROR;
                                   }
				   if (!verify_mailbox(parse_script, (yyvsp[(3) - (3)].sval))) {
				     YYERROR; /* vm should call yyerror() */
				   }
	                           (yyval.cl) = build_fileinto(FILEINTO, (yyvsp[(2) - (3)].nval), (yyvsp[(3) - (3)].sval)); }
    break;

  case 17:
/* Line 1813 of yacc.c  */
#line 305 "sieve/sieve.y"
    { if (!verify_address(parse_script, (yyvsp[(3) - (3)].sval))) {
				     YYERROR; /* va should call yyerror() */
				   }
	                           (yyval.cl) = build_redirect(REDIRECT, (yyvsp[(2) - (3)].nval), (yyvsp[(3) - (3)].sval)); }
    break;

  case 18:
/* Line 1813 of yacc.c  */
#line 309 "sieve/sieve.y"
    { (yyval.cl) = new_command(KEEP); }
    break;

  case 19:
/* Line 1813 of yacc.c  */
#line 310 "sieve/sieve.y"
    { (yyval.cl) = new_command(STOP); }
    break;

  case 20:
/* Line 1813 of yacc.c  */
#line 311 "sieve/sieve.y"
    { (yyval.cl) = new_command(DISCARD); }
    break;

  case 21:
/* Line 1813 of yacc.c  */
#line 312 "sieve/sieve.y"
    { if (!parse_script->support.vacation) {
				     yyerror(parse_script, "vacation MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   if (((yyvsp[(2) - (3)].vtag)->mime == -1) && !verify_utf8(parse_script, (yyvsp[(3) - (3)].sval))) {
				     YYERROR; /* vu should call yyerror() */
				   }
  				   (yyval.cl) = build_vacation(VACATION,
					    canon_vtags(parse_script, (yyvsp[(2) - (3)].vtag)), (yyvsp[(3) - (3)].sval)); }
    break;

  case 22:
/* Line 1813 of yacc.c  */
#line 321 "sieve/sieve.y"
    { if (!parse_script->support.imapflags) {
                                    yyerror(parse_script, "imapflags MUST be enabled with \"require\"");
                                    YYERROR;
                                   }
                                  if (!verify_stringlist(parse_script, (yyvsp[(2) - (2)].sl), verify_flag)) {
                                    YYERROR; /* vf should call yyerror() */
                                  }
                                  (yyval.cl) = new_command(SETFLAG);
                                  (yyval.cl)->u.sl = (yyvsp[(2) - (2)].sl); }
    break;

  case 23:
/* Line 1813 of yacc.c  */
#line 330 "sieve/sieve.y"
    { if (!parse_script->support.imapflags) {
                                    yyerror(parse_script, "imapflags MUST be enabled with \"require\"");
                                    YYERROR;
                                    }
                                  if (!verify_stringlist(parse_script, (yyvsp[(2) - (2)].sl), verify_flag)) {
                                    YYERROR; /* vf should call yyerror() */
                                  }
                                  (yyval.cl) = new_command(ADDFLAG);
                                  (yyval.cl)->u.sl = (yyvsp[(2) - (2)].sl); }
    break;

  case 24:
/* Line 1813 of yacc.c  */
#line 339 "sieve/sieve.y"
    { if (!parse_script->support.imapflags) {
                                    yyerror(parse_script, "imapflags MUST be enabled with \"require\"");
                                    YYERROR;
                                    }
                                  if (!verify_stringlist(parse_script, (yyvsp[(2) - (2)].sl), verify_flag)) {
                                    YYERROR; /* vf should call yyerror() */
                                  }
                                  (yyval.cl) = new_command(REMOVEFLAG);
                                  (yyval.cl)->u.sl = (yyvsp[(2) - (2)].sl); }
    break;

  case 25:
/* Line 1813 of yacc.c  */
#line 348 "sieve/sieve.y"
    { if (!parse_script->support.imapflags) {
                                    yyerror(parse_script, "imapflags MUST be enabled with \"require\"");
                                    YYERROR;
                                    }
                                  (yyval.cl) = new_command(MARK); }
    break;

  case 26:
/* Line 1813 of yacc.c  */
#line 353 "sieve/sieve.y"
    { if (!parse_script->support.imapflags) {
                                    yyerror(parse_script, "imapflags MUST be enabled with \"require\"");
                                    YYERROR;
                                    }
                                  (yyval.cl) = new_command(UNMARK); }
    break;

  case 27:
/* Line 1813 of yacc.c  */
#line 359 "sieve/sieve.y"
    { if (!parse_script->support.notify) {
				       yyerror(parse_script, "notify MUST be enabled with \"require\"");
				       (yyval.cl) = new_command(NOTIFY); 
				       YYERROR;
	 			    } else {
				      (yyval.cl) = build_notify(NOTIFY,
				             canon_ntags((yyvsp[(2) - (2)].ntag)));
				    } }
    break;

  case 28:
/* Line 1813 of yacc.c  */
#line 367 "sieve/sieve.y"
    { if (!parse_script->support.notify) {
                                       yyerror(parse_script, "notify MUST be enabled with \"require\"");
				       (yyval.cl) = new_command(DENOTIFY);
				       YYERROR;
				    } else {
					(yyval.cl) = build_denotify(DENOTIFY, canon_dtags((yyvsp[(2) - (2)].dtag)));
					if ((yyval.cl) == NULL) { 
			yyerror(parse_script, "unable to find a compatible comparator");
			YYERROR; } } }
    break;

  case 29:
/* Line 1813 of yacc.c  */
#line 377 "sieve/sieve.y"
    { if (!parse_script->support.include) {
				     yyerror(parse_script, "include MUST be enabled with \"require\"");
	                             YYERROR;
                                   }
				   int i;
				   for (i = 0; (yyvsp[(3) - (3)].sval)[i] != '\0'; i++) {
				     if ((yyvsp[(3) - (3)].sval)[i] == '/') {
				       yyerror(parse_script, "included script name must not contain slash"); YYERROR;
				       break;
				     }
				   }
				   (yyval.cl) = build_include(INCLUDE, (yyvsp[(2) - (3)].itag), (yyvsp[(3) - (3)].sval));
				 }
    break;

  case 30:
/* Line 1813 of yacc.c  */
#line 390 "sieve/sieve.y"
    { if (!parse_script->support.include) {
                                    yyerror(parse_script, "include MUST be enabled with \"require\"");
                                    YYERROR;
                                  }
                                   (yyval.cl) = new_command(RETURN); }
    break;

  case 31:
/* Line 1813 of yacc.c  */
#line 397 "sieve/sieve.y"
    { (yyval.itag) = new_itags(); }
    break;

  case 32:
/* Line 1813 of yacc.c  */
#line 398 "sieve/sieve.y"
    { if ((yyval.itag)->location != -1) {
				     yyerror(parse_script, "duplicate location (:personal or :global)"); YYERROR; }
				   else { (yyval.itag)->location = PERSONAL; }}
    break;

  case 33:
/* Line 1813 of yacc.c  */
#line 401 "sieve/sieve.y"
    { if ((yyval.itag)->location != -1) {
				     yyerror(parse_script, "duplicate location (:personal or :global)"); YYERROR; }
				   else { (yyval.itag)->location = GLOBAL; }}
    break;

  case 34:
/* Line 1813 of yacc.c  */
#line 404 "sieve/sieve.y"
    { if ((yyval.itag)->once != -1) {
				     yyerror(parse_script, "duplicate :once"); YYERROR; }
				   else { (yyval.itag)->once = 1; }}
    break;

  case 35:
/* Line 1813 of yacc.c  */
#line 407 "sieve/sieve.y"
    { if ((yyval.itag)->optional != -1) {
				     yyerror(parse_script, "duplicate :optional"); YYERROR; }
				   else { (yyval.itag)->optional = 1; }}
    break;

  case 36:
/* Line 1813 of yacc.c  */
#line 412 "sieve/sieve.y"
    { (yyval.ntag) = new_ntags(); }
    break;

  case 37:
/* Line 1813 of yacc.c  */
#line 413 "sieve/sieve.y"
    { if ((yyval.ntag)->id != NULL) { 
					yyerror(parse_script, "duplicate :method"); YYERROR; }
				   else { (yyval.ntag)->id = (yyvsp[(3) - (3)].sval); } }
    break;

  case 38:
/* Line 1813 of yacc.c  */
#line 416 "sieve/sieve.y"
    { if ((yyval.ntag)->method != NULL) { 
					yyerror(parse_script, "duplicate :method"); YYERROR; }
				   else { (yyval.ntag)->method = (yyvsp[(3) - (3)].sval); } }
    break;

  case 39:
/* Line 1813 of yacc.c  */
#line 419 "sieve/sieve.y"
    { if ((yyval.ntag)->options != NULL) { 
					yyerror(parse_script, "duplicate :options"); YYERROR; }
				     else { (yyval.ntag)->options = (yyvsp[(3) - (3)].sl); } }
    break;

  case 40:
/* Line 1813 of yacc.c  */
#line 422 "sieve/sieve.y"
    { if ((yyval.ntag)->priority != -1) { 
                                 yyerror(parse_script, "duplicate :priority"); YYERROR; }
                                   else { (yyval.ntag)->priority = (yyvsp[(2) - (2)].nval); } }
    break;

  case 41:
/* Line 1813 of yacc.c  */
#line 425 "sieve/sieve.y"
    { if ((yyval.ntag)->message != NULL) { 
					yyerror(parse_script, "duplicate :message"); YYERROR; }
				   else { (yyval.ntag)->message = (yyvsp[(3) - (3)].sval); } }
    break;

  case 42:
/* Line 1813 of yacc.c  */
#line 430 "sieve/sieve.y"
    { (yyval.dtag) = new_dtags(); }
    break;

  case 43:
/* Line 1813 of yacc.c  */
#line 431 "sieve/sieve.y"
    { if ((yyval.dtag)->priority != -1) { 
				yyerror(parse_script, "duplicate priority level"); YYERROR; }
				   else { (yyval.dtag)->priority = (yyvsp[(2) - (2)].nval); } }
    break;

  case 44:
/* Line 1813 of yacc.c  */
#line 434 "sieve/sieve.y"
    { if ((yyval.dtag)->comptag != -1)
	                             { 
					 yyerror(parse_script, "duplicate comparator type tag"); YYERROR;
				     }
	                           (yyval.dtag)->comptag = (yyvsp[(2) - (3)].nval);
#ifdef ENABLE_REGEX
				   if ((yyval.dtag)->comptag == REGEX)
				   {
				       int cflags = REG_EXTENDED |
					   REG_NOSUB | REG_ICASE;
				       if (!verify_regex(parse_script, (yyvsp[(3) - (3)].sval), cflags)) { YYERROR; }
				   }
#endif
				   (yyval.dtag)->pattern = (yyvsp[(3) - (3)].sval);
	                          }
    break;

  case 45:
/* Line 1813 of yacc.c  */
#line 449 "sieve/sieve.y"
    { (yyval.dtag) = (yyvsp[(1) - (3)].dtag);
				   if ((yyval.dtag)->comptag != -1) { 
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.dtag)->comptag = (yyvsp[(2) - (3)].nval);
				   (yyval.dtag)->relation = verify_relat(parse_script, (yyvsp[(3) - (3)].sval));
				   if ((yyval.dtag)->relation==-1) 
				     {YYERROR; /*vr called yyerror()*/ }
				   } }
    break;

  case 46:
/* Line 1813 of yacc.c  */
#line 459 "sieve/sieve.y"
    { (yyval.nval) = LOW; }
    break;

  case 47:
/* Line 1813 of yacc.c  */
#line 460 "sieve/sieve.y"
    { (yyval.nval) = NORMAL; }
    break;

  case 48:
/* Line 1813 of yacc.c  */
#line 461 "sieve/sieve.y"
    { (yyval.nval) = HIGH; }
    break;

  case 49:
/* Line 1813 of yacc.c  */
#line 464 "sieve/sieve.y"
    { (yyval.vtag) = new_vtags(); }
    break;

  case 50:
/* Line 1813 of yacc.c  */
#line 465 "sieve/sieve.y"
    { if ((yyval.vtag)->seconds != -1) {
					yyerror(parse_script, "duplicate :days or :seconds"); YYERROR; }
				   else { (yyval.vtag)->seconds = (yyvsp[(3) - (3)].nval) * DAY2SEC; } }
    break;

  case 51:
/* Line 1813 of yacc.c  */
#line 468 "sieve/sieve.y"
    { if (!parse_script->support.vacation_seconds) {
				     yyerror(parse_script, "vacation-seconds not required");
				     YYERROR;
				   }
				   if ((yyval.vtag)->seconds != -1) {
					yyerror(parse_script, "duplicate :days or :seconds"); YYERROR; }
				   else { (yyval.vtag)->seconds = (yyvsp[(3) - (3)].nval); } }
    break;

  case 52:
/* Line 1813 of yacc.c  */
#line 475 "sieve/sieve.y"
    { if ((yyval.vtag)->addresses != NULL) {
					yyerror(parse_script, "duplicate :addresses");
					YYERROR;
				       } else if (!verify_stringlist(parse_script, (yyvsp[(3) - (3)].sl),
							verify_address)) {
					  YYERROR;
				       } else {
					 (yyval.vtag)->addresses = (yyvsp[(3) - (3)].sl); } }
    break;

  case 53:
/* Line 1813 of yacc.c  */
#line 483 "sieve/sieve.y"
    { if ((yyval.vtag)->subject != NULL) { 
					yyerror(parse_script, "duplicate :subject");
					YYERROR;
				   } else if (!verify_utf8(parse_script, (yyvsp[(3) - (3)].sval))) {
				        YYERROR; /* vu should call yyerror() */
				   } else { (yyval.vtag)->subject = (yyvsp[(3) - (3)].sval); } }
    break;

  case 54:
/* Line 1813 of yacc.c  */
#line 489 "sieve/sieve.y"
    { if ((yyval.vtag)->from != NULL) { 
					yyerror(parse_script, "duplicate :from");
					YYERROR;
				   } else if (!verify_address(parse_script, (yyvsp[(3) - (3)].sval))) {
				        YYERROR; /* vu should call yyerror() */
				   } else { (yyval.vtag)->from = (yyvsp[(3) - (3)].sval); } }
    break;

  case 55:
/* Line 1813 of yacc.c  */
#line 495 "sieve/sieve.y"
    { if ((yyval.vtag)->handle != NULL) { 
					yyerror(parse_script, "duplicate :handle");
					YYERROR;
				   } else if (!verify_utf8(parse_script, (yyvsp[(3) - (3)].sval))) {
				        YYERROR; /* vu should call yyerror() */
				   } else { (yyval.vtag)->handle = (yyvsp[(3) - (3)].sval); } }
    break;

  case 56:
/* Line 1813 of yacc.c  */
#line 501 "sieve/sieve.y"
    { if ((yyval.vtag)->mime != -1) { 
					yyerror(parse_script, "duplicate :mime");
					YYERROR; }
				   else { (yyval.vtag)->mime = MIME; } }
    break;

  case 57:
/* Line 1813 of yacc.c  */
#line 507 "sieve/sieve.y"
    { (yyval.sl) = (yyvsp[(2) - (3)].sl); }
    break;

  case 58:
/* Line 1813 of yacc.c  */
#line 508 "sieve/sieve.y"
    {
				    (yyval.sl) = strarray_new();
				    strarray_appendm((yyval.sl), (yyvsp[(1) - (1)].sval));
				 }
    break;

  case 59:
/* Line 1813 of yacc.c  */
#line 514 "sieve/sieve.y"
    {
				    (yyval.sl) = strarray_new();
				    strarray_appendm((yyval.sl), (yyvsp[(1) - (1)].sval));
				 }
    break;

  case 60:
/* Line 1813 of yacc.c  */
#line 518 "sieve/sieve.y"
    {
				    (yyval.sl) = (yyvsp[(1) - (3)].sl);
				    strarray_appendm((yyval.sl), (yyvsp[(3) - (3)].sval));
				 }
    break;

  case 61:
/* Line 1813 of yacc.c  */
#line 524 "sieve/sieve.y"
    { (yyval.cl) = (yyvsp[(2) - (3)].cl); }
    break;

  case 62:
/* Line 1813 of yacc.c  */
#line 525 "sieve/sieve.y"
    { (yyval.cl) = NULL; }
    break;

  case 63:
/* Line 1813 of yacc.c  */
#line 528 "sieve/sieve.y"
    { (yyval.test) = new_test(ANYOF); (yyval.test)->u.tl = (yyvsp[(2) - (2)].testl); }
    break;

  case 64:
/* Line 1813 of yacc.c  */
#line 529 "sieve/sieve.y"
    { (yyval.test) = new_test(ALLOF); (yyval.test)->u.tl = (yyvsp[(2) - (2)].testl); }
    break;

  case 65:
/* Line 1813 of yacc.c  */
#line 530 "sieve/sieve.y"
    { (yyval.test) = new_test(EXISTS); (yyval.test)->u.sl = (yyvsp[(2) - (2)].sl); }
    break;

  case 66:
/* Line 1813 of yacc.c  */
#line 531 "sieve/sieve.y"
    { (yyval.test) = new_test(SFALSE); }
    break;

  case 67:
/* Line 1813 of yacc.c  */
#line 532 "sieve/sieve.y"
    { (yyval.test) = new_test(STRUE); }
    break;

  case 68:
/* Line 1813 of yacc.c  */
#line 534 "sieve/sieve.y"
    {
				     if (!verify_stringlist(parse_script, (yyvsp[(3) - (4)].sl), verify_header)) {
					 YYERROR; /* vh should call yyerror() */
				     }
				     if (!verify_stringlist(parse_script, (yyvsp[(4) - (4)].sl), verify_utf8)) {
					 YYERROR; /* vu should call yyerror() */
				     }
				     
				     (yyvsp[(2) - (4)].htag) = canon_htags((yyvsp[(2) - (4)].htag));
#ifdef ENABLE_REGEX
				     if ((yyvsp[(2) - (4)].htag)->comptag == REGEX)
				     {
					 if (!(verify_regexs(parse_script, (yyvsp[(4) - (4)].sl), (yyvsp[(2) - (4)].htag)->comparator)))
					 { YYERROR; }
				     }
#endif
				     (yyval.test) = build_header(HEADER, (yyvsp[(2) - (4)].htag), (yyvsp[(3) - (4)].sl), (yyvsp[(4) - (4)].sl));
				     if ((yyval.test) == NULL) { 
					 yyerror(parse_script, "unable to find a compatible comparator");
					 YYERROR; } 
				 }
    break;

  case 69:
/* Line 1813 of yacc.c  */
#line 558 "sieve/sieve.y"
    { 
				     if (((yyvsp[(1) - (4)].nval) == ADDRESS) &&
					 !verify_stringlist(parse_script, (yyvsp[(3) - (4)].sl), verify_addrheader))
					 { YYERROR; }
				     else if (((yyvsp[(1) - (4)].nval) == ENVELOPE) &&
					      !verify_stringlist(parse_script, (yyvsp[(3) - (4)].sl), verify_envelope))
					 { YYERROR; }
				     (yyvsp[(2) - (4)].aetag) = canon_aetags((yyvsp[(2) - (4)].aetag));
#ifdef ENABLE_REGEX
				     if ((yyvsp[(2) - (4)].aetag)->comptag == REGEX)
				     {
					 if (!( verify_regexs(parse_script, (yyvsp[(4) - (4)].sl), (yyvsp[(2) - (4)].aetag)->comparator)))
					 { YYERROR; }
				     }
#endif
				     (yyval.test) = build_address((yyvsp[(1) - (4)].nval), (yyvsp[(2) - (4)].aetag), (yyvsp[(3) - (4)].sl), (yyvsp[(4) - (4)].sl));
				     if ((yyval.test) == NULL) { 
					 yyerror(parse_script, "unable to find a compatible comparator");
					 YYERROR; } 
				 }
    break;

  case 70:
/* Line 1813 of yacc.c  */
#line 580 "sieve/sieve.y"
    {
				     if (!parse_script->support.body) {
                                       yyerror(parse_script, "body MUST be enabled with \"require\"");
				       YYERROR;
				     }
					
				     if (!verify_stringlist(parse_script, (yyvsp[(3) - (3)].sl), verify_utf8)) {
					 YYERROR; /* vu should call yyerror() */
				     }
				     
				     (yyvsp[(2) - (3)].btag) = canon_btags((yyvsp[(2) - (3)].btag));
#ifdef ENABLE_REGEX
				     if ((yyvsp[(2) - (3)].btag)->comptag == REGEX)
				     {
					 if (!(verify_regexs(parse_script, (yyvsp[(3) - (3)].sl), (yyvsp[(2) - (3)].btag)->comparator)))
					 { YYERROR; }
				     }
#endif
				     (yyval.test) = build_body(BODY, (yyvsp[(2) - (3)].btag), (yyvsp[(3) - (3)].sl));
				     if ((yyval.test) == NULL) { 
					 yyerror(parse_script, "unable to find a compatible comparator");
					 YYERROR; } 
				 }
    break;

  case 71:
/* Line 1813 of yacc.c  */
#line 605 "sieve/sieve.y"
    { (yyval.test) = new_test(NOT); (yyval.test)->u.t = (yyvsp[(2) - (2)].test); }
    break;

  case 72:
/* Line 1813 of yacc.c  */
#line 606 "sieve/sieve.y"
    { (yyval.test) = new_test(SIZE); (yyval.test)->u.sz.t = (yyvsp[(2) - (3)].nval);
		                   (yyval.test)->u.sz.n = (yyvsp[(3) - (3)].nval); }
    break;

  case 73:
/* Line 1813 of yacc.c  */
#line 609 "sieve/sieve.y"
    {
                                   (yyvsp[(2) - (5)].dttag)->date_part = verify_date_part(parse_script, (yyvsp[(4) - (5)].sval));
                                   if ((yyvsp[(2) - (5)].dttag)->date_part == -1)
                                     { YYERROR; /*vr called yyerror()*/ }

                                   (yyvsp[(2) - (5)].dttag) = canon_dttags((yyvsp[(2) - (5)].dttag));

                                   (yyval.test) = build_date(DATE, (yyvsp[(2) - (5)].dttag), (yyvsp[(3) - (5)].sval), (yyvsp[(5) - (5)].sl));
                                   if ((yyval.test) == NULL) {
                                     yyerror(parse_script, "unable to find a compatible comparator");
                                     YYERROR; }
                                 }
    break;

  case 74:
/* Line 1813 of yacc.c  */
#line 622 "sieve/sieve.y"
    {
                                   (yyvsp[(2) - (5)].dttag)->date_part = verify_date_part(parse_script, (yyvsp[(4) - (5)].sval));
                                   if ((yyvsp[(2) - (5)].dttag)->date_part == -1)
                                     { YYERROR; /*vr called yyerror()*/ }

                                   (yyvsp[(2) - (5)].dttag) = canon_dttags((yyvsp[(2) - (5)].dttag));

                                   (yyval.test) = build_date(CURRENTDATE, (yyvsp[(2) - (5)].dttag), (yyvsp[(3) - (5)].sval), (yyvsp[(5) - (5)].sl));
                                   if ((yyval.test) == NULL) {
                                     yyerror(parse_script, "unable to find a compatible comparator");
                                     YYERROR; }
                                 }
    break;

  case 75:
/* Line 1813 of yacc.c  */
#line 634 "sieve/sieve.y"
    { (yyval.test) = NULL; }
    break;

  case 76:
/* Line 1813 of yacc.c  */
#line 637 "sieve/sieve.y"
    { (yyval.nval) = ADDRESS; }
    break;

  case 77:
/* Line 1813 of yacc.c  */
#line 638 "sieve/sieve.y"
    {if (!parse_script->support.envelope)
	                              {yyerror(parse_script, "envelope MUST be enabled with \"require\""); YYERROR;}
	                          else{(yyval.nval) = ENVELOPE; }
	                         }
    break;

  case 78:
/* Line 1813 of yacc.c  */
#line 645 "sieve/sieve.y"
    { (yyval.aetag) = new_aetags(); }
    break;

  case 79:
/* Line 1813 of yacc.c  */
#line 646 "sieve/sieve.y"
    { (yyval.aetag) = (yyvsp[(1) - (2)].aetag);
				   if ((yyval.aetag)->addrtag != -1) {
			yyerror(parse_script, "duplicate or conflicting address part tag");
			YYERROR; }
				   else { (yyval.aetag)->addrtag = (yyvsp[(2) - (2)].nval); } }
    break;

  case 80:
/* Line 1813 of yacc.c  */
#line 651 "sieve/sieve.y"
    { (yyval.aetag) = (yyvsp[(1) - (2)].aetag);
				   if ((yyval.aetag)->comptag != -1) {
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.aetag)->comptag = (yyvsp[(2) - (2)].nval); } }
    break;

  case 81:
/* Line 1813 of yacc.c  */
#line 655 "sieve/sieve.y"
    { (yyval.aetag) = (yyvsp[(1) - (3)].aetag);
				   if ((yyval.aetag)->comptag != -1) {
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.aetag)->comptag = (yyvsp[(2) - (3)].nval);
				   (yyval.aetag)->relation = verify_relat(parse_script, (yyvsp[(3) - (3)].sval));
				   if ((yyval.aetag)->relation==-1)
				     {YYERROR; /*vr called yyerror()*/ }
				   } }
    break;

  case 82:
/* Line 1813 of yacc.c  */
#line 663 "sieve/sieve.y"
    { (yyval.aetag) = (yyvsp[(1) - (3)].aetag);
				   if ((yyval.aetag)->comparator != NULL) {
				     yyerror(parse_script, "duplicate comparator tag"); YYERROR; }
				   else if (!strcmp((yyvsp[(3) - (3)].sval), "i;ascii-numeric") &&
					    !parse_script->support.i_ascii_numeric) {
			yyerror(parse_script, "comparator-i;ascii-numeric MUST be enabled with \"require\"");
			YYERROR; }
				   else { (yyval.aetag)->comparator = (yyvsp[(3) - (3)].sval); } }
    break;

  case 83:
/* Line 1813 of yacc.c  */
#line 673 "sieve/sieve.y"
    { (yyval.htag) = new_htags(); }
    break;

  case 84:
/* Line 1813 of yacc.c  */
#line 674 "sieve/sieve.y"
    { (yyval.htag) = (yyvsp[(1) - (2)].htag);
				   if ((yyval.htag)->comptag != -1) { 
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.htag)->comptag = (yyvsp[(2) - (2)].nval); } }
    break;

  case 85:
/* Line 1813 of yacc.c  */
#line 678 "sieve/sieve.y"
    { (yyval.htag) = (yyvsp[(1) - (3)].htag);
				   if ((yyval.htag)->comptag != -1) { 
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.htag)->comptag = (yyvsp[(2) - (3)].nval);
				   (yyval.htag)->relation = verify_relat(parse_script, (yyvsp[(3) - (3)].sval));
				   if ((yyval.htag)->relation==-1) 
				     {YYERROR; /*vr called yyerror()*/ }
				   } }
    break;

  case 86:
/* Line 1813 of yacc.c  */
#line 686 "sieve/sieve.y"
    { (yyval.htag) = (yyvsp[(1) - (3)].htag);
				   if ((yyval.htag)->comparator != NULL) { 
			 yyerror(parse_script, "duplicate comparator tag"); YYERROR; }
				   else if (!strcmp((yyvsp[(3) - (3)].sval), "i;ascii-numeric") &&
					    !parse_script->support.i_ascii_numeric) { 
			 yyerror(parse_script, "comparator-i;ascii-numeric MUST be enabled with \"require\"");  YYERROR; }
				   else { 
				     (yyval.htag)->comparator = (yyvsp[(3) - (3)].sval); } }
    break;

  case 87:
/* Line 1813 of yacc.c  */
#line 696 "sieve/sieve.y"
    { (yyval.btag) = new_btags(); }
    break;

  case 88:
/* Line 1813 of yacc.c  */
#line 697 "sieve/sieve.y"
    { (yyval.btag) = (yyvsp[(1) - (2)].btag);
				   if ((yyval.btag)->transform != -1) {
			yyerror(parse_script, "duplicate or conflicting transform tag");
			YYERROR; }
				   else { (yyval.btag)->transform = RAW; } }
    break;

  case 89:
/* Line 1813 of yacc.c  */
#line 702 "sieve/sieve.y"
    { (yyval.btag) = (yyvsp[(1) - (2)].btag);
				   if ((yyval.btag)->transform != -1) {
			yyerror(parse_script, "duplicate or conflicting transform tag");
			YYERROR; }
				   else { (yyval.btag)->transform = TEXT; } }
    break;

  case 90:
/* Line 1813 of yacc.c  */
#line 707 "sieve/sieve.y"
    { (yyval.btag) = (yyvsp[(1) - (3)].btag);
				   if ((yyval.btag)->transform != -1) {
			yyerror(parse_script, "duplicate or conflicting transform tag");
			YYERROR; }
				   else {
				       (yyval.btag)->transform = CONTENT;
				       (yyval.btag)->content_types = (yyvsp[(3) - (3)].sl);
				   } }
    break;

  case 91:
/* Line 1813 of yacc.c  */
#line 715 "sieve/sieve.y"
    { (yyval.btag) = (yyvsp[(1) - (2)].btag);
				   if ((yyval.btag)->comptag != -1) { 
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.btag)->comptag = (yyvsp[(2) - (2)].nval); } }
    break;

  case 92:
/* Line 1813 of yacc.c  */
#line 719 "sieve/sieve.y"
    { (yyval.btag) = (yyvsp[(1) - (3)].btag);
				   if ((yyval.btag)->comptag != -1) { 
			yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
				   else { (yyval.btag)->comptag = (yyvsp[(2) - (3)].nval);
				   (yyval.btag)->relation = verify_relat(parse_script, (yyvsp[(3) - (3)].sval));
				   if ((yyval.btag)->relation==-1) 
				     {YYERROR; /*vr called yyerror()*/ }
				   } }
    break;

  case 93:
/* Line 1813 of yacc.c  */
#line 727 "sieve/sieve.y"
    { (yyval.btag) = (yyvsp[(1) - (3)].btag);
				   if ((yyval.btag)->comparator != NULL) { 
			 yyerror(parse_script, "duplicate comparator tag"); YYERROR; }
				   else if (!strcmp((yyvsp[(3) - (3)].sval), "i;ascii-numeric") &&
					    !parse_script->support.i_ascii_numeric) { 
			 yyerror(parse_script, "comparator-i;ascii-numeric MUST be enabled with \"require\"");  YYERROR; }
				   else { 
				     (yyval.btag)->comparator = (yyvsp[(3) - (3)].sval); } }
    break;

  case 94:
/* Line 1813 of yacc.c  */
#line 737 "sieve/sieve.y"
    { (yyval.dttag) = new_dttags(); }
    break;

  case 95:
/* Line 1813 of yacc.c  */
#line 738 "sieve/sieve.y"
    { (yyval.dttag) = (yyvsp[(1) - (2)].dttag);
                                   if ((yyval.dttag)->comptag != -1) {
                                     yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
                                   else { (yyval.dttag)->comptag = (yyvsp[(2) - (2)].nval); } }
    break;

  case 96:
/* Line 1813 of yacc.c  */
#line 743 "sieve/sieve.y"
    { (yyval.dttag) = (yyvsp[(1) - (3)].dttag);
                                   if ((yyval.dttag)->comptag != -1) {
                                     yyerror(parse_script, "duplicate comparator type tag"); YYERROR; }
                                   else {
                                     (yyval.dttag)->comptag = (yyvsp[(2) - (3)].nval);
                                     (yyval.dttag)->relation = verify_relat(parse_script, (yyvsp[(3) - (3)].sval));
                                     if ((yyval.dttag)->relation == -1) {
                                       YYERROR; /*vr called yyerror()*/ } } }
    break;

  case 97:
/* Line 1813 of yacc.c  */
#line 752 "sieve/sieve.y"
    { (yyval.dttag) = (yyvsp[(1) - (3)].dttag);
                                    if ((yyval.dttag)->comparator != NULL) {
                                      yyerror(parse_script, "duplicate comparator tag"); YYERROR; }
                                    else if (!strcmp((yyvsp[(3) - (3)].sval), "i;ascii-numeric") &&
                                      !parse_script->support.i_ascii_numeric) {
                                      yyerror(parse_script, "comparator-i;ascii-numeric MUST be enabled with \"require\"");  YYERROR; }
                                    else { (yyval.dttag)->comparator = (yyvsp[(3) - (3)].sval); } }
    break;

  case 98:
/* Line 1813 of yacc.c  */
#line 760 "sieve/sieve.y"
    { (yyval.dttag) = (yyvsp[(1) - (3)].dttag);
                                   if ((yyval.dttag)->zonetag != -1) {
                                     yyerror(parse_script, "duplicate zone tag"); YYERROR; }
                                   else {
                                     if (verify_zone(parse_script, (yyvsp[(3) - (3)].sval)) == -1) {
                                       YYERROR; /*vr called yyerror()*/ }
                                     else { (yyval.dttag)->zone = (yyvsp[(3) - (3)].sval);
                                            (yyval.dttag)->zonetag = ZONE; } } }
    break;

  case 99:
/* Line 1813 of yacc.c  */
#line 769 "sieve/sieve.y"
    { (yyval.dttag) = (yyvsp[(1) - (2)].dttag);
                                   if ((yyval.dttag)->zonetag != -1) {
                                     yyerror(parse_script, "duplicate zone tag"); YYERROR; }
                                   else { (yyval.dttag)->zonetag = ORIGINALZONE; } }
    break;

  case 100:
/* Line 1813 of yacc.c  */
#line 775 "sieve/sieve.y"
    { (yyval.nval) = ALL; }
    break;

  case 101:
/* Line 1813 of yacc.c  */
#line 776 "sieve/sieve.y"
    { (yyval.nval) = LOCALPART; }
    break;

  case 102:
/* Line 1813 of yacc.c  */
#line 777 "sieve/sieve.y"
    { (yyval.nval) = DOMAIN; }
    break;

  case 103:
/* Line 1813 of yacc.c  */
#line 778 "sieve/sieve.y"
    { if (!parse_script->support.subaddress) {
				     yyerror(parse_script, "subaddress MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   (yyval.nval) = USER; }
    break;

  case 104:
/* Line 1813 of yacc.c  */
#line 783 "sieve/sieve.y"
    { if (!parse_script->support.subaddress) {
				     yyerror(parse_script, "subaddress MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   (yyval.nval) = DETAIL; }
    break;

  case 105:
/* Line 1813 of yacc.c  */
#line 789 "sieve/sieve.y"
    { (yyval.nval) = IS; }
    break;

  case 106:
/* Line 1813 of yacc.c  */
#line 790 "sieve/sieve.y"
    { (yyval.nval) = CONTAINS; }
    break;

  case 107:
/* Line 1813 of yacc.c  */
#line 791 "sieve/sieve.y"
    { (yyval.nval) = MATCHES; }
    break;

  case 108:
/* Line 1813 of yacc.c  */
#line 792 "sieve/sieve.y"
    { if (!parse_script->support.regex) {
				     yyerror(parse_script, "regex MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   (yyval.nval) = REGEX; }
    break;

  case 109:
/* Line 1813 of yacc.c  */
#line 799 "sieve/sieve.y"
    { if (!parse_script->support.relational) {
				     yyerror(parse_script, "relational MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   (yyval.nval) = COUNT; }
    break;

  case 110:
/* Line 1813 of yacc.c  */
#line 804 "sieve/sieve.y"
    { if (!parse_script->support.relational) {
				     yyerror(parse_script, "relational MUST be enabled with \"require\"");
				     YYERROR;
				   }
				   (yyval.nval) = VALUE; }
    break;

  case 111:
/* Line 1813 of yacc.c  */
#line 812 "sieve/sieve.y"
    { (yyval.nval) = OVER; }
    break;

  case 112:
/* Line 1813 of yacc.c  */
#line 813 "sieve/sieve.y"
    { (yyval.nval) = UNDER; }
    break;

  case 113:
/* Line 1813 of yacc.c  */
#line 816 "sieve/sieve.y"
    { (yyval.nval) = 0; }
    break;

  case 114:
/* Line 1813 of yacc.c  */
#line 817 "sieve/sieve.y"
    { if (!parse_script->support.copy) {
				     yyerror(parse_script, "copy MUST be enabled with \"require\"");
	                             YYERROR;
                                   }
				   (yyval.nval) = COPY; }
    break;

  case 115:
/* Line 1813 of yacc.c  */
#line 824 "sieve/sieve.y"
    { (yyval.testl) = (yyvsp[(2) - (3)].testl); }
    break;

  case 116:
/* Line 1813 of yacc.c  */
#line 827 "sieve/sieve.y"
    { (yyval.testl) = new_testlist((yyvsp[(1) - (1)].test), NULL); }
    break;

  case 117:
/* Line 1813 of yacc.c  */
#line 828 "sieve/sieve.y"
    { (yyval.testl) = new_testlist((yyvsp[(1) - (3)].test), (yyvsp[(3) - (3)].testl)); }
    break;


/* Line 1813 of yacc.c  */
#line 3109 "sieve/sieve.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (parse_script, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (parse_script, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, parse_script);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, parse_script);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (parse_script, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, parse_script);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, parse_script);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2076 of yacc.c  */
#line 831 "sieve/sieve.y"

void yyerror(sieve_script_t *parse_script, const char *msg)
{
    parse_script->err++;
    if (parse_script->interp.err) {
	parse_script->interp.err(sievelineno, msg, 
				 parse_script->interp.interp_context,
				 parse_script->script_context);
    }
}

static char *check_reqs(sieve_script_t *parse_script, strarray_t *sa)
{
    char *s;
    struct buf errs = BUF_INITIALIZER;
    char *res;

    while ((s = strarray_shift(sa))) {
	if (!script_require(parse_script, s)) {
	    if (!errs.len)
		buf_printf(&errs, "Unsupported feature(s) in \"require\": \"%s\"", s);
	    else
		buf_printf(&errs, ", \"%s\"", s);
	}
	free(s);
    }
    strarray_free(sa);

    res = buf_release(&errs);
    if (!res[0]) {
	free(res);
	return NULL;
    }

    return res;
}

static test_t *build_address(int t, struct aetags *ae,
			     strarray_t *sl, strarray_t *pl)
{
    test_t *ret = new_test(t);	/* can be either ADDRESS or ENVELOPE */

    assert((t == ADDRESS) || (t == ENVELOPE));

    if (ret) {
	ret->u.ae.comptag = ae->comptag;
	ret->u.ae.relation=ae->relation;
	ret->u.ae.comparator=xstrdup(ae->comparator);
	ret->u.ae.sl = sl;
	ret->u.ae.pl = pl;
	ret->u.ae.addrpart = ae->addrtag;
	free_aetags(ae);

    }
    return ret;
}

static test_t *build_header(int t, struct htags *h,
			    strarray_t *sl, strarray_t *pl)
{
    test_t *ret = new_test(t);	/* can be HEADER */

    assert(t == HEADER);

    if (ret) {
	ret->u.h.comptag = h->comptag;
	ret->u.h.relation=h->relation;
	ret->u.h.comparator=xstrdup(h->comparator);
	ret->u.h.sl = sl;
	ret->u.h.pl = pl;
	free_htags(h);
    }
    return ret;
}

static test_t *build_body(int t, struct btags *b, strarray_t *pl)
{
    test_t *ret = new_test(t);	/* can be BODY */

    assert(t == BODY);

    if (ret) {
	ret->u.b.comptag = b->comptag;
	ret->u.b.relation = b->relation;
	ret->u.b.comparator = xstrdup(b->comparator);
	ret->u.b.transform = b->transform;
	ret->u.b.offset = b->offset;
	ret->u.b.content_types = b->content_types; b->content_types = NULL;
	ret->u.b.pl = pl;
	free_btags(b);
    }
    return ret;
}

static commandlist_t *build_vacation(int t, struct vtags *v, char *reason)
{
    commandlist_t *ret = new_command(t);

    assert(t == VACATION);

    if (ret) {
	ret->u.v.subject = v->subject; v->subject = NULL;
	ret->u.v.from = v->from; v->from = NULL;
	ret->u.v.handle = v->handle; v->handle = NULL;
	ret->u.v.seconds = v->seconds;
	ret->u.v.mime = v->mime;
	ret->u.v.addresses = v->addresses; v->addresses = NULL;
	free_vtags(v);
	ret->u.v.message = reason;
    }
    return ret;
}

static commandlist_t *build_notify(int t, struct ntags *n)
{
    commandlist_t *ret = new_command(t);

    assert(t == NOTIFY);
       if (ret) {
	ret->u.n.method = n->method; n->method = NULL;
	ret->u.n.id = n->id; n->id = NULL;
	ret->u.n.options = n->options; n->options = NULL;
	ret->u.n.priority = n->priority;
	ret->u.n.message = n->message; n->message = NULL;
	free_ntags(n);
    }
    return ret;
}

static commandlist_t *build_denotify(int t, struct dtags *d)
{
    commandlist_t *ret = new_command(t);

    assert(t == DENOTIFY);

    if (ret) {
	ret->u.d.comptag = d->comptag;
	ret->u.d.relation=d->relation;
	ret->u.d.pattern = d->pattern; d->pattern = NULL;
	ret->u.d.priority = d->priority;
	free_dtags(d);
    }
    return ret;
}

static commandlist_t *build_fileinto(int t, int copy, char *folder)
{
    commandlist_t *ret = new_command(t);

    assert(t == FILEINTO);

    if (ret) {
	ret->u.f.copy = copy;
	if (config_getswitch(IMAPOPT_SIEVE_UTF8FILEINTO)) {
	    ret->u.f.folder = xmalloc(5 * strlen(folder) + 1);
	    UTF8_to_mUTF7(ret->u.f.folder, folder);
	    free(folder);
	}
	else {
	    ret->u.f.folder = folder;
	}
    }
    return ret;
}

static commandlist_t *build_redirect(int t, int copy, char *address)
{
    commandlist_t *ret = new_command(t);

    assert(t == REDIRECT);

    if (ret) {
	ret->u.r.copy = copy;
	ret->u.r.address = address;
    }
    return ret;
}

static commandlist_t *build_include(int t, struct itags *i, char* script)
{
    commandlist_t *ret = new_command(t);

    assert(t == INCLUDE);

    if (i->location == -1) i->location = PERSONAL;
    if (i->once == -1) i->once = 0;
    if (i->optional == -1) i->optional = 0;

    if (ret) {
	ret->u.inc.location = i->location;
	ret->u.inc.once = i->once;
	ret->u.inc.optional = i->optional;
	ret->u.inc.script = script;
	free(i);
    }
    return ret;
}

static test_t *build_date(int t, struct dttags *dt,
    char *hn, strarray_t *kl)
{
    test_t *ret = new_test(t);
    assert(t == DATE || t == CURRENTDATE);

    if (ret) {
        ret->u.dt.zone = (dt->zone ? xstrdup(dt->zone) : NULL);
        ret->u.dt.comparator = xstrdup(dt->comparator);
        ret->u.dt.zonetag = dt->zonetag;
        ret->u.dt.comptag = dt->comptag;
        ret->u.dt.relation = dt->relation;
        ret->u.dt.date_part = dt->date_part;
        ret->u.dt.header_name = hn;
        ret->u.dt.kl = kl;
        free_dttags(dt);
    }
    return ret;
}


static struct aetags *new_aetags(void)
{
    struct aetags *r = (struct aetags *) xmalloc(sizeof(struct aetags));

    r->addrtag = r->comptag = r->relation=-1;
    r->comparator=NULL;

    return r;
}

static struct aetags *canon_aetags(struct aetags *ae)
{
    if (ae->addrtag == -1) { ae->addrtag = ALL; }
    if (ae->comparator == NULL) {
        ae->comparator = xstrdup("i;ascii-casemap");
    }
    if (ae->comptag == -1) { ae->comptag = IS; }
    return ae;
}

static void free_aetags(struct aetags *ae)
{
    free(ae->comparator);
     free(ae);
}

static struct htags *new_htags(void)
{
    struct htags *r = (struct htags *) xmalloc(sizeof(struct htags));

    r->comptag = r->relation= -1;
    
    r->comparator = NULL;

    return r;
}

static struct htags *canon_htags(struct htags *h)
{
    if (h->comparator == NULL) {
	h->comparator = xstrdup("i;ascii-casemap");
    }
    if (h->comptag == -1) { h->comptag = IS; }
    return h;
}

static void free_htags(struct htags *h)
{
    free(h->comparator);
    free(h);
}

static struct btags *new_btags(void)
{
    struct btags *r = (struct btags *) xmalloc(sizeof(struct btags));

    r->transform = r->offset = r->comptag = r->relation = -1;
    r->content_types = NULL;
    r->comparator = NULL;

    return r;
}

static struct btags *canon_btags(struct btags *b)
{
    if (b->transform == -1) { b->transform = TEXT; }
    if (b->content_types == NULL) {
	b->content_types = strarray_new();
	if (b->transform == RAW) {
	    strarray_append(b->content_types, "");
	} else {
	    strarray_append(b->content_types, "text");
	}
    }
    if (b->offset == -1) { b->offset = 0; }
    if (b->comparator == NULL) { b->comparator = xstrdup("i;ascii-casemap"); }
    if (b->comptag == -1) { b->comptag = IS; }
    return b;
}

static void free_btags(struct btags *b)
{
    if (b->content_types) { strarray_free(b->content_types); }
    free(b->comparator);
    free(b);
}

static struct vtags *new_vtags(void)
{
    struct vtags *r = (struct vtags *) xmalloc(sizeof(struct vtags));

    r->seconds = -1;
    r->addresses = NULL;
    r->subject = NULL;
    r->from = NULL;
    r->handle = NULL;
    r->mime = -1;

    return r;
}

static struct vtags *canon_vtags(sieve_script_t *parse_script, struct vtags *v)
{
    assert(parse_script->interp.vacation != NULL);

    if (v->seconds == -1) { v->seconds = 7 * DAY2SEC; }
    if (v->seconds < parse_script->interp.vacation->min_response)
       { v->seconds = parse_script->interp.vacation->min_response; }
    if (v->seconds > parse_script->interp.vacation->max_response)
       { v->seconds = parse_script->interp.vacation->max_response; }
    if (v->mime == -1) { v->mime = 0; }

    return v;
}

static void free_vtags(struct vtags *v)
{
    if (v->addresses) { strarray_free(v->addresses); }
    if (v->subject) { free(v->subject); }
    if (v->from) { free(v->from); }
    if (v->handle) { free(v->handle); }
    free(v);
}

static struct itags *new_itags() {
    struct itags *r = (struct itags *) xmalloc(sizeof(struct itags));

    r->once = -1;
    r->location = -1;
    r->optional = -1;

    return r;
}

static struct dttags *new_dttags(void)
{
    struct dttags *dt = (struct dttags *) xmalloc(sizeof(struct dttags));
    dt->comptag = -1;
    dt->zonetag = -1;
    dt->relation = -1;
    dt->comparator = NULL;
    dt->zone = NULL;
    dt->date_part = -1;
    return dt;
}

static struct dttags *canon_dttags(struct dttags *dt)
{
    char zone[6];
    int gmoffset;
    int hours;
    int minutes;
    struct tm *tm;
    time_t t;

    if (dt->comparator == NULL) {
        dt->comparator = xstrdup("i;ascii-casemap");
    }
    if (dt->zonetag == -1) {
        t = time(NULL);
        tm = localtime(&t);
        gmoffset = gmtoff_of(tm, t) / 60;
        hours = abs(gmoffset) / 60;
        minutes = abs(gmoffset) % 60;
        snprintf(zone, 6, "%c%02d%02d", (gmoffset >= 0 ? '+' : '-'), hours, minutes);
        dt->zone = xstrdup(zone);
        dt->zonetag = ZONE;
    }
    if (dt->comptag == -1) {
        dt->comptag = IS;
    }
    return dt;
}

static void free_dttags(struct dttags *dt)
{
    free(dt->comparator);
    free(dt->zone);
    free(dt);
}


static struct ntags *new_ntags(void)
{
    struct ntags *r = (struct ntags *) xmalloc(sizeof(struct ntags));

    r->method = NULL;
    r->id = NULL;
    r->options = NULL;
    r->priority = -1;
    r->message = NULL;

    return r;
}

static struct ntags *canon_ntags(struct ntags *n)
{
    if (n->priority == -1) { n->priority = NORMAL; }
    if (n->message == NULL) { n->message = xstrdup("$from$: $subject$"); }
    if (n->method == NULL) { n->method = xstrdup("default"); }
    return n;
}
static struct dtags *canon_dtags(struct dtags *d)
{
    if (d->priority == -1) { d->priority = ANY; }
    if (d->comptag == -1) { d->comptag = ANY; }
       return d;
}

static void free_ntags(struct ntags *n)
{
    if (n->method) { free(n->method); }
    if (n->id) { free(n->id); }
    if (n->options) { strarray_free(n->options); }
    if (n->message) { free(n->message); }
    free(n);
}

static struct dtags *new_dtags(void)
{
    struct dtags *r = (struct dtags *) xmalloc(sizeof(struct dtags));

    r->comptag = r->priority= r->relation = -1;
    r->pattern  = NULL;

    return r;
}

static void free_dtags(struct dtags *d)
{
    if (d->pattern) free(d->pattern);
    free(d);
}

static int verify_stringlist(sieve_script_t *parse_script, strarray_t *sa, int (*verify)(sieve_script_t*, char *))
{
    int i;

    for (i = 0 ; i < sa->count ; i++)
	if (!verify(parse_script, sa->data[i]))
	    return 0;
    return 1;
}

static int verify_address(sieve_script_t *parse_script, char *s)
{
    parse_script->addrerr[0] = '\0';	/* paranoia */
    YY_BUFFER_STATE buffer = addr_scan_string(s);
    if (addrparse(parse_script)) {
	snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
		 "address '%s': %s", s, parse_script->addrerr);
	yyerror(parse_script, parse_script->sieveerr);
	addr_delete_buffer(buffer);
	return 0;
    }
    addr_delete_buffer(buffer);
    return 1;
}

static int verify_mailbox(sieve_script_t *parse_script, char *s)
{
    if (!verify_utf8(parse_script, s)) return 0;

    /* xxx if not a mailbox, call yyerror */
    return 1;
}

static int verify_header(sieve_script_t *parse_script, char *hdr)
{
    char *h = hdr;

    while (*h) {
	/* field-name      =       1*ftext
	   ftext           =       %d33-57 / %d59-126         
	   ; Any character except
	   ;  controls, SP, and
	   ;  ":". */
	if (!((*h >= 33 && *h <= 57) || (*h >= 59 && *h <= 126))) {
	    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
		     "header '%s': not a valid header", hdr);
	    yyerror(parse_script, parse_script->sieveerr);
	    return 0;
	}
	h++;
    }
    return 1;
}
 
static int verify_addrheader(sieve_script_t *parse_script, char *hdr)
{
    const char **h, *hdrs[] = {
	"from", "sender", "reply-to",	/* RFC2822 originator fields */
	"to", "cc", "bcc",		/* RFC2822 destination fields */
	"resent-from", "resent-sender",	/* RFC2822 resent fields */
	"resent-to", "resent-cc", "resent-bcc",
	"return-path",			/* RFC2822 trace fields */
	"disposition-notification-to",	/* RFC2298 MDN request fields */
	"delivered-to",			/* non-standard (loop detection) */
	"approved",			/* RFC1036 moderator/control fields */
	NULL
    };

    if (!config_getswitch(IMAPOPT_RFC3028_STRICT))
        return verify_header(parse_script, hdr);

    for (lcase(hdr), h = hdrs; *h; h++) {
	if (!strcmp(*h, hdr)) return 1;
    }

    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
	     "header '%s': not a valid header for an address test", hdr);
    yyerror(parse_script, parse_script->sieveerr);
    return 0;
}
 
static int verify_envelope(sieve_script_t *parse_script, char *env)
{
    lcase(env);
    if (!config_getswitch(IMAPOPT_RFC3028_STRICT) ||
	!strcmp(env, "from") || !strcmp(env, "to") || !strcmp(env, "auth")) {
	return 1;
    }

    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
	     "env-part '%s': not a valid part for an envelope test", env);
    yyerror(parse_script, parse_script->sieveerr);
    return 0;
}
 
static int verify_relat(sieve_script_t *parse_script, char *r)
{/* this really should have been a token to begin with.*/
	lcase(r);
	if (!strcmp(r, "gt")) {return GT;}
	else if (!strcmp(r, "ge")) {return GE;}
	else if (!strcmp(r, "lt")) {return LT;}
	else if (!strcmp(r, "le")) {return LE;}
	else if (!strcmp(r, "ne")) {return NE;}
	else if (!strcmp(r, "eq")) {return EQ;}
	else{
	  snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
		   "flag '%s': not a valid relational operation", r);
	  yyerror(parse_script, parse_script->sieveerr);
	  return -1;
	}
	
}

static int verify_zone(sieve_script_t *parse_script, char *tz)
{
    int valid = 0;
    unsigned hours;
    unsigned minutes;
    char sign;

    if (sscanf(tz, "%c%02u%02u", &sign, &hours, &minutes) != 3) {
        valid |= -1;
    }

    // test sign
    switch (sign) {
    case '+':
    case '-':
        break;

    default:
        valid |= -1;
        break;
    }

    // test minutes
    if (minutes > 59) {
            valid |= -1;
    }

    if (valid != 0) {
        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
                 "flag '%s': not a valid timezone offset", tz);
        yyerror(parse_script, parse_script->sieveerr);
    }

    return valid;
}

static int verify_date_part(sieve_script_t *parse_script, char *dp)
{
    lcase(dp);
    if (!strcmp(dp, "year")) { return YEAR; }
    else if (!strcmp(dp, "month")) { return MONTH; }
    else if (!strcmp(dp, "day")) { return DAY; }
    else if (!strcmp(dp, "date")) { return DATE; }
    else if (!strcmp(dp, "julian")) { return JULIAN; }
    else if (!strcmp(dp, "hour")) { return HOUR; }
    else if (!strcmp(dp, "minute")) { return MINUTE; }
    else if (!strcmp(dp, "second")) { return SECOND; }
    else if (!strcmp(dp, "time")) { return TIME; }
    else if (!strcmp(dp, "iso8601")) { return ISO8601; }
    else if (!strcmp(dp, "std11")) { return STD11; }
    else if (!strcmp(dp, "zone")) { return ZONE; }
    else if (!strcmp(dp, "weekday")) { return WEEKDAY; }
    else {
        snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
                 "flag '%s': not a valid relational operation", dp);
        yyerror(parse_script, parse_script->sieveerr);
    }

    return -1;
}




static int verify_flag(sieve_script_t *parse_script, char *f)
{
    if (f[0] == '\\') {
	lcase(f);
	if (strcmp(f, "\\seen") && strcmp(f, "\\answered") &&
	    strcmp(f, "\\flagged") && strcmp(f, "\\draft") &&
	    strcmp(f, "\\deleted")) {
	    snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
		     "flag '%s': not a system flag", f);
	    yyerror(parse_script, parse_script->sieveerr);
	    return 0;
	}
	return 1;
    }
    if (!imparse_isatom(f)) {
	snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
		 "flag '%s': not a valid keyword", f);
	yyerror(parse_script, parse_script->sieveerr);
	return 0;
    }
    return 1;
}
 
#ifdef ENABLE_REGEX
static int verify_regex(sieve_script_t *parse_script, char *s, int cflags)
{
    int ret;
    regex_t *reg = (regex_t *) xmalloc(sizeof(regex_t));

#ifdef HAVE_PCREPOSIX_H
    /* support UTF8 comparisons */
    cflags |= REG_UTF8;
#endif

    if ((ret = regcomp(reg, s, cflags)) != 0) {
	(void) regerror(ret, reg, parse_script->sieveerr, ERR_BUF_SIZE);
	yyerror(parse_script, parse_script->sieveerr);
	free(reg);
	return 0;
    }
    free(reg);
    return 1;
}

static int verify_regexs(sieve_script_t *parse_script, const strarray_t *sa, char *comp)
{
    int i;
    int cflags = REG_EXTENDED | REG_NOSUB;

    if (!strcmp(comp, "i;ascii-casemap")) {
	cflags |= REG_ICASE;
    }

    for (i = 0 ; i < sa->count ; i++) {
	if ((verify_regex(parse_script, sa->data[i], cflags)) == 0)
	    return 0;
    }
    return 1;
}
#endif

/*
 * Valid UTF-8 check (from RFC 2640 Annex B.1)
 *
 * The following routine checks if a byte sequence is valid UTF-8. This
 * is done by checking for the proper tagging of the first and following
 * bytes to make sure they conform to the UTF-8 format. It then checks
 * to assure that the data part of the UTF-8 sequence conforms to the
 * proper range allowed by the encoding. Note: This routine will not
 * detect characters that have not been assigned and therefore do not
 * exist.
 */
static int verify_utf8(sieve_script_t *parse_script, char *s)
{
    const char *buf = s;
    const char *endbuf = s + strlen(s);
    unsigned char byte2mask = 0x00, c;
    int trailing = 0;  /* trailing (continuation) bytes to follow */

    while (buf != endbuf) {
	c = *buf++;
	if (trailing) {
	    if ((c & 0xC0) == 0x80) {		/* Does trailing byte
						   follow UTF-8 format? */
		if (byte2mask) {		/* Need to check 2nd byte
						   for proper range? */
		    if (c & byte2mask)		/* Are appropriate bits set? */
			byte2mask = 0x00;
		    else
			break;
		}
		trailing--;
	    }
	    else
		break;
	}
	else {
	    if ((c & 0x80) == 0x00)		/* valid 1 byte UTF-8 */
		continue;
	    else if ((c & 0xE0) == 0xC0)	/* valid 2 byte UTF-8 */
		if (c & 0x1E) {			/* Is UTF-8 byte
						   in proper range? */
		    trailing = 1;
		}
		else
		    break;
	    else if ((c & 0xF0) == 0xE0) {	/* valid 3 byte UTF-8 */
		if (!(c & 0x0F)) {		/* Is UTF-8 byte
						   in proper range? */
		    byte2mask = 0x20;		/* If not, set mask
						   to check next byte */
		}
		trailing = 2;
	    }
	    else if ((c & 0xF8) == 0xF0) {	/* valid 4 byte UTF-8 */
		if (!(c & 0x07)) {		/* Is UTF-8 byte
						   in proper range? */
		    byte2mask = 0x30;		/* If not, set mask
						   to check next byte */
		}
		trailing = 3;
	    }
	    else if ((c & 0xFC) == 0xF8) {	/* valid 5 byte UTF-8 */
		if (!(c & 0x03)) {		/* Is UTF-8 byte
						   in proper range? */
		    byte2mask = 0x38;		/* If not, set mask
						   to check next byte */
		}
		trailing = 4;
	    }
	    else if ((c & 0xFE) == 0xFC) {	/* valid 6 byte UTF-8 */
		if (!(c & 0x01)) {		/* Is UTF-8 byte
						   in proper range? */
		    byte2mask = 0x3C;		/* If not, set mask
						   to check next byte */
		}
		trailing = 5;
	    }
	    else
		break;
	}
    }

    if ((buf != endbuf) || trailing) {
	snprintf(parse_script->sieveerr, ERR_BUF_SIZE,
		 "string '%s': not valid utf8", s);
	yyerror(parse_script, parse_script->sieveerr);
	return 0;
    }

    return 1;
}
